#include <stdio.h>
#include <stdlib.h>
#include <time.h>

#define ON_TARGET_1 30000 // Spieler 1 im Ziel
#define ON_TARGET_2 30001 // Spieler 2 im Ziel
#define ON_TARGET_3 30002 // Spieler 3 im Ziel
#define ON_TARGET_4 30003 // Spieler 4 im Ziel

#define POS_X0 10 // X-Position
#define POS_Y0 5  // Y-Position

#define SIZE_X 10 // Spielfeldgre X, Min 3, Max 20
#define SIZE_Y 7  // Spielfeldgre Y, Min 3, Max 10

void setCursor(int y, int x) {
	printf("\033[%d;%dH", y, x);
}

void initField() {
    int i;
    printf("\033[2J");  // Bildschirm loeschen
    for (i = 0; i < SIZE_X; i++) {
		setCursor(POS_Y0, POS_X0 + i); printf("o");
        setCursor(POS_Y0 + SIZE_Y - 1, POS_X0 + i); printf("o");
    }
    for (i = 0; i < (SIZE_Y-2); i++) {
		setCursor(POS_Y0 + 1 + i, POS_X0); printf("o");
        setCursor(POS_Y0 + 1 + i, POS_X0 + SIZE_X - 1); printf("o");
    }
	setCursor(POS_Y0, POS_X0 - 2); printf("->");
	setCursor(POS_Y0 - 1, POS_X0 + 1); printf("1234");
	setCursor(POS_Y0 + SIZE_Y + 1, POS_X0 + 1); printf("____");
}

int whichPlayer(int pl, int az) {
    int f;
    setCursor(POS_Y0, POS_X0 + SIZE_X + 3); 
	printf("Spieler %d", pl);
    setCursor(POS_Y0 + 2, POS_X0 + SIZE_X + 3);
	if (pl == 1)
		printf("Kegel 1 oder 2 (AZ = %d)? ", az);
	else
		printf("Kegel 3 oder 4 (AZ = %d)? ", az);
    scanf("%d", &f);
	return f;
}

void takenPosition() {
    setCursor(POS_Y0 + 2, POS_X0 + SIZE_X + 3);
    printf("Position leider schon besetzt\n");
    sleep(2);
    setCursor(POS_Y0 + 2, POS_X0 + SIZE_X + 3);
    printf("                             \n");
}

void deleteHome(int pl) {
 	setCursor(POS_Y0 - 1, POS_X0 + pl);
    printf("_");
}

void setGoal(int pl) {
	setCursor(POS_Y0 + SIZE_Y + 1, POS_X0 + pl);
    printf("%d", pl);
}

void setPlayer(int pl, int l, char ch) {
    int b = SIZE_X - 1;
    int h = SIZE_Y - 1;
    if ( (pl%l) < b )
        setCursor(POS_Y0,POS_X0+(pl%l) );
    else if ( (pl%l) < (b + h) )
        setCursor(POS_Y0+((pl%l)-b),POS_X0+b);
    else if ( (pl%l) < (b+h+b) )
        setCursor(POS_Y0+h,POS_X0+b-((pl%l)-b-h));
    else
        setCursor(POS_Y0+h-((pl%l)-b-h-b),POS_X0);
    printf("%c", ch);
}

void removePlayer(int pl) {
	setCursor(POS_Y0 - 1, POS_X0 + pl);
	printf("%d", pl);
}

int main () {

	// Spieler 1, Spieler 2 (jeweils 2 Kegel)
	int pl1 = -1, pl2 = -1, pl3 = -1, pl4 = -1;
	// Frage, Augenzahl, Spielfeldlnge
	int kegel, az, laenge; 
	time_t t;

	// Zufallsgenerator initialisieren;
	time(&t);
	srand((unsigned int)t);

	// Spielfeldlnge
	laenge = 2 * SIZE_X + 2 * SIZE_Y - 4;

	initField();

	do {

		// Spieler 1
		az = (rand() % 6) + 1; // Wuerfeln

		// Welchen Kegel ziehen?
		do {
			kegel = whichPlayer(1, az);
		} while ( (kegel != 1 || pl1 >= ON_TARGET_1) && (kegel != 2 || pl2 >= ON_TARGET_2) );

		// Kegel 1
		if (kegel == 1) {

			if ((pl1 + az) == pl2) takenPosition();
			else {

				// Vorhergehenden Position loeschen
				if (pl1 == -1) deleteHome(1);
				else setPlayer(pl1, laenge, 'o');

				// Spieler bewegen
				pl1 = pl1 + az;					

				// Ziel erreicht;
				if (pl1 >= laenge) {
					setGoal(1);
					pl1 = ON_TARGET_1;
				}
				else
					setPlayer(pl1, laenge, '1');

				// Kann anderer Kegel geschlagen werden?
				if (pl1 == pl3) {
					pl3 = -1;
					removePlayer(3);
				}
				else if (pl1 == pl4) {
					pl4 = -1;
					removePlayer(4);
				}
			}
		}

		// Kegel 2
		else {
			if ((pl2 + az) == pl1) takenPosition();
			else {
                // Vorhergehenden Position loeschen
                if (pl2 == -1) deleteHome(2);
                else setPlayer(pl2, laenge, 'o');
				pl2 = pl2 + az;

                // Ziel erreicht;
                if (pl2 >= laenge) {
                    setGoal(2);
                    pl2 = ON_TARGET_2;
                }
                else
                    setPlayer(pl2, laenge, '2');

                // Kann anderer Kegel geschlagen werden?
                if (pl2 == pl3) {
                    pl3 = -1;
                    removePlayer(3);
                }
                else if (pl2 == pl4) {
                    pl4 = -1;
                    removePlayer(4);
                }
			}
		}


		// Spieler 2
		az = (rand() % 6) + 1;
		do {
			kegel = whichPlayer(2, az);
		} while ( (kegel != 3 || pl3 >= ON_TARGET_3) && (kegel != 4 || pl4 >= ON_TARGET_4) );

		// Kegel 3
		if (kegel == 3) {
			if ((pl3 + az) == pl4) takenPosition();
			else {
                // Vorhergehenden Position loeschen
                if (pl3 == -1) deleteHome(3);
                else setPlayer(pl3, laenge, 'o');

				pl3 = pl3 + az;

                // Ziel erreicht;
                if (pl3 >= laenge) {
                    setGoal(3);
                    pl3 = ON_TARGET_3;
                }
                else
                    setPlayer(pl3, laenge, '3');

                // Kann anderer Kegel geschlagen werden?
                if (pl3 == pl1) {
                    pl1 = -1;
                    removePlayer(1);
                }
                else if (pl3 == pl2) {
                    pl2 = -1;
                    removePlayer(2);
                }
			}
		}

		// Kegel 4
		else {
			if ((pl4 + az) == pl3) takenPosition();
			else {
                // Vorhergehenden Position loeschen
                if (pl4 == -1) deleteHome(4);
                else setPlayer(pl4, laenge, 'o');

				pl4 = pl4 + az;

                // Ziel erreicht;
                if (pl4 >= laenge) {
                    setGoal(4);
                    pl4 = ON_TARGET_4;
                }
                else
                    setPlayer(pl4, laenge, '4');

                // Kann anderer Kegel geschlagen werden?
                if (pl4 == pl1) {
                    pl1 = -1;
                    removePlayer(1);
                }
                else if (pl4 == pl2) {
                    pl2 = -1;
                    removePlayer(2);
                }
			}
		}

	} while ( (pl1 < laenge || pl2 < laenge) &&
			  (pl3 < laenge || pl4 < laenge) );

	// Gewonnen hat...
	setCursor(POS_Y0 + SIZE_Y + 3, POS_X0);
	if (pl1 == ON_TARGET_1 && pl2 == ON_TARGET_2 && pl3 == ON_TARGET_3 && pl4 == ON_TARGET_4) 
		printf("Unentschieden!\n\n");
	else if (pl1 == ON_TARGET_1 && pl2 == ON_TARGET_2) 
		printf("Spieler 1 hat gewonnen!\n\n");
	else if (pl3 == ON_TARGET_3 && pl4 == ON_TARGET_4) 
		printf("Spieler 2 hat gewonnen!\n\n");

	return 0;
}
